#include <allegro.h>
#include <math.h>
#include "main.h"

int main()
{
	allegro_init();
	install_keyboard();
	install_mouse();
	install_timer();

	text_mode(-1);
	set_color_depth(32);
	set_gfx_mode(GFX_AUTODETECT_WINDOWED, 800, 600, 0, 0);
	buffer = create_bitmap(SCREEN_W, SCREEN_H);
	bloodbmp = create_bitmap(SCREEN_W, SCREEN_H);
	crosshairbmp = load_bitmap("crosshair.bmp", NULL);
	frenbmp = load_bitmap("frenbmp.bmp", NULL);
	trollbmp = load_bitmap("trollbmp.bmp", NULL);
	playerbmp = load_bitmap("playerbmp.bmp", NULL);

	RED = makecol32(255, 0, 0);
	TROLLGREEN = makecol32(0, 128, 64);
	fdegtorad = (PI/180);

	LOCK_VARIABLE(icurfps);
	LOCK_VARIABLE(ifps);
	LOCK_FUNCTION(Do_FPS);
	install_int(Do_FPS, 1000);

	LOCK_VARIABLE(ilogic);
	LOCK_FUNCTION(Inc_ilogic);
	install_int(Inc_ilogic, 1000/30);

	player = new Player();
	for (int i = 0; i < MAX_TROLL; i++)
		troll[i] = new Troll();
	for (i = 0; i < MAX_PARTICLE; i++)
		part[i] = new Particle();
	for (i = 0; i < MAX_SINEWAVE; i++)
		swave[i] = new SineWave();


	clear_to_color(bloodbmp, makecol32(192, 192, 96));

	bautofire = false;

	frespawn = 120.0f;

	for (i = 0; i < 10; i++)
	{
		troll[i]->balive = true;
		troll[i]->fx = rand()%800;
		troll[i]->fy = rand()%600;
		troll[i]->ihp = rand()%2+1;
		troll[i]->fspeed = (rand()%20)/10.0f + 1.2f;
	}

	while (!key[KEY_ESC])
	{
		if (ilogic)
		{
			blit(bloodbmp, buffer, 0, 0, 0, 0, SCREEN_W, SCREEN_H);

			frespawn -= 0.02f;
// + (rand()%50)/10
			ispawnn--;
			if (ispawnn <= 0)
			{
				for (int n = 0; n < rand()%4; n++)
				{
					for (int x = 0; x < MAX_TROLL; x++)
					{
						if (!troll[x]->balive)
						{
							troll[x]->balive = true;
							troll[x]->fx = rand()%SCREEN_W;
							troll[x]->fy = 0.0;
							troll[x]->ihp = rand()%2+1;
							troll[x]->fspeed = (rand()%20)/10.0f + 1.2f;
							break;
						}
					}
				}
				ispawnn = frespawn + (rand()%50)/10;
			}
			ispawne--;
			if (ispawne <= 0)
			{
				for (int n = 0; n < rand()%4; n++)
				{
					for (int x = 0; x < MAX_TROLL; x++)
					{
						if (!troll[x]->balive)
						{
							troll[x]->balive = true;
							troll[x]->fx = SCREEN_W;
							troll[x]->fy = rand()%SCREEN_H;
							troll[x]->ihp = rand()%2+1;
							troll[x]->fspeed = (rand()%20)/10.0f + 1.2f;
							break;
						}
					}
				}
				ispawne = frespawn + (rand()%50)/10;
			}
			ispawnw--;
			if (ispawnw <= 0)
			{
				for (int n = 0; n < rand()%4; n++)
				{
					for (int x = 0; x < MAX_TROLL; x++)
					{
						if (!troll[x]->balive)
						{
							troll[x]->balive = true;
							troll[x]->fx = 0;
							troll[x]->fy = rand()%SCREEN_H;
							troll[x]->ihp = rand()%2+1;
							troll[x]->fspeed = (rand()%20)/10.0f + 1.2f;
							break;
						}
					}
				}
				ispawnw = frespawn + (rand()%50)/10;
			}
			ispawns--;
			if (ispawns <= 0)
			{
				for (int n = 0; n < rand()%4; n++)
				{
					for (int x = 0; x < MAX_TROLL; x++)
					{
						if (!troll[x]->balive)
						{
							troll[x]->balive = true;
							troll[x]->fx = rand()%SCREEN_W;
							troll[x]->fy = SCREEN_H;
							troll[x]->ihp = rand()%2+1;
							troll[x]->fspeed = (rand()%20)/10.0f + 1.2f;
							break;
						}

					}
				}
				ispawns = frespawn + (rand()%50)/10;
			}

			
			Troll_Logic();
			SineWave_Logic();
			Player_Logic();
			Particle_Logic();

			Draw_Player();
			Draw_Trolls();
			Draw_Particles();
			Draw_SineWaves();

			if (iscore >= 64 && !bautofire)
			{
				bautofire = true;
				ifrencounter = 150;
				frespawn /= 3;
			}

			masked_blit(crosshairbmp, buffer, 0, 0, mouse_x-crosshairbmp->w/2, mouse_y-crosshairbmp->h/2, crosshairbmp->w, crosshairbmp->h);
			rect(buffer, 389, 9, 791, 21, makecol32(0,255,0));
			rectfill(buffer, 790-(player->ihealth*4), 10, 790, 20, makecol32(0,0,255));
			rect(buffer, 389, 19, 791, 31, makecol32(255,255,0));
			rectfill(buffer, 790-(player->iheat*4), 20, 790, 30, makecol32(255,0,0));
			textprintf(buffer, font, 10, 10, makecol32(255,255,255), "%0000i", iscore);

			if (ifrencounter > 0)
			{
				ifrencounter --;
				masked_blit(frenbmp, buffer, 0, 0, 200, 375, frenbmp->w, frenbmp->h);
			}


			blit(buffer, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
			ifps++;
			ilogic--;
		}
	}

	allegro_exit();
	delete player;
	for (i = 0; i < MAX_TROLL; i++)
		delete troll[i];
	for (i = 0; i < MAX_PARTICLE; i++)
		delete part[i];
	for (i = 0; i < MAX_SINEWAVE; i++)
		delete swave[i];


	return 0;
}
END_OF_MAIN();

void Inc_ilogic()
{
	ilogic++;
}END_OF_FUNCTION(Inc_ilogic);

void Do_FPS()
{
	icurfps = ifps;
	ifps = 0;
}END_OF_FUNCTION(Do_FPS);

Player::Player()
{
	ftargetx =
	ftargety = fvx = fvy = 0.0f;
	fx = SCREEN_W/2;
	fy = SCREEN_H/2;
	icooldown = 0;
	ihealth = START_HEALTH;
	iheat = 0;
}

Particle::Particle()
{
	balive = false;
	fx = fy = fvx = fvy = 0.0f;
	ilife = icolor = 0;
}

SineWave::SineWave()
{
	balive = false;
	fstep = fvx = fvy = fx = fy = fcos = fsin = fcosp = fsinp = 0.0f;
}

Troll::Troll()
{
	balive = false;
	fspeed = fx = fy = fstep = 0.0f;
	ihp = icolor = 0;
}

void Troll_Logic()
{
	for (int i = 0; i < MAX_TROLL; i++)
	{
		if (troll[i]->balive)
		{
			float fdx = player->fx - troll[i]->fx;
			float fdy = player->fy - troll[i]->fy;
			float flen = sq(fdx)+sq(fdy);
			if (flen < TROLL_RANGE)
			{
				troll[i]->balive = false;
				BloodSplat(troll[i]->fx, troll[i]->fy, -fdx, -fdy);
				player->ihealth -= 5;
			}else
			{
				flen = sqrt(flen);
				troll[i]->fx += fdx/flen*(troll[i]->fspeed*sin(troll[i]->fstep));
				troll[i]->fy += fdy/flen*(troll[i]->fspeed*sin(troll[i]->fstep));
			}
			troll[i]->fstep += TROLLSTEP;
			if (troll[i]->fstep > PI)
				troll[i]->fstep = 0;

		}
	}
}

void Draw_Trolls()
{
	for (int i = 0; i < MAX_TROLL; i++)
	{
		if (troll[i]->balive)
		{
			float fangle = -atan2(player->fy - troll[i]->fy, player->fx - troll[i]->fx);
			if (fangle > -(PI/4) && fangle < (PI/4))
				masked_blit(trollbmp, buffer, 0, 0, troll[i]->fx-8, troll[i]->fy-8, 16, 16);
			else if (fangle > (PI/4) && fangle < (PI/4)*3)
				masked_blit(trollbmp, buffer, 48, 0, troll[i]->fx-8, troll[i]->fy-8, 16, 16);
			else if (fangle > (PI/4)*3 || fangle < -(PI/4)*3)
				masked_blit(trollbmp, buffer, 32, 0, troll[i]->fx-8, troll[i]->fy-8, 16, 16);
			else if (fangle > -(PI/4)*3 && fangle < -(PI/4))
				masked_blit(trollbmp, buffer, 16, 0, troll[i]->fx-8, troll[i]->fy-8, 16, 16);
		}
	}
}

void Player_Logic()
{
	player->fvy *= DRAG;
	player->fvx *= DRAG;
	if (key[KEY_W])
		player->fvy -= ACCEL;
	if (key[KEY_S])
		player->fvy += ACCEL;
	if (key[KEY_A])
		player->fvx -= ACCEL;
	if (key[KEY_D])
		player->fvx += ACCEL;
	if (key[KEY_F2])
		iscore+=10;

	player->fx += player->fvx;
	player->fy += player->fvy;

	float fspeed = (player->fvx*player->fvx)+(player->fvy*player->fvy);
	if (fspeed > MAX_SPEED*MAX_SPEED)
	{
		fspeed = sqrt(fspeed);
		player->fvx = player->fvx / fspeed * MAX_SPEED;
		player->fvy = player->fvy / fspeed * MAX_SPEED;
	}

	if ((mouse_b & 1) && (player->icooldown == 0) && (player->iheat < (100-SHOTHEAT)))
	{
		if (!ShootSineWave(player->fx, player->fy, mouse_x - player->fx, mouse_y - player->fy))
		{
			if (bautofire)
			{
				player->icooldown = COOLDOWN/3;
				player->iheat += SHOTHEAT/5;
			}else
			{
				player->icooldown = COOLDOWN;
				player->iheat += SHOTHEAT;
			}
		}
	}

	if (player->icooldown > 0)
		player->icooldown --;
	if (player->iheat > 0)
		player->iheat --;

}

void Draw_Player()
{
	float fangle = atan2(mouse_y-player->fy, mouse_x-player->fx)-(PI/2);
	if (fangle > -(PI/4) && fangle < (PI/4))
		masked_blit(playerbmp, buffer, 0, 0, player->fx-8, player->fy-8, 16, 16);
	else if (fangle > (PI/4) && fangle < (PI/4)*3)
		masked_blit(playerbmp, buffer, 16, 0, player->fx-8, player->fy-8, 16, 16);
	else if (fangle > (PI/4)*3 || fangle < -(PI/4)*3)
		masked_blit(playerbmp, buffer, 32, 0, player->fx-8, player->fy-8, 16, 16);
	else if (fangle > -(PI/4)*3 && fangle < -(PI/4))
		masked_blit(playerbmp, buffer, 48, 0, player->fx-8, player->fy-8, 16, 16);

}

void Particle_Logic()
{
	
	for (int i = 0; i < MAX_PARTICLE; i++)
	{
		if (part[i]->balive)
		{
			part[i]->fx += part[i]->fvx;
			part[i]->fy += part[i]->fvy;
			if (part[i]->ilife <= 0)
			{
				circlefill(bloodbmp, min(max(0, (int)(part[i]->fx) ), SCREEN_W-1), min(max(0, (int)(part[i]->fy) ), SCREEN_H-1), 1, part[i]->icolor);
				part[i]->balive = false;
			}
			part[i]->ilife --;
		}
	}
}

void Draw_Particles()
{
	for (int i = 0; i < MAX_PARTICLE; i++)
	{
		if (part[i]->balive)
			putpixel(buffer, (int)(part[i]->fx), (int)(part[i]->fy), part[i]->icolor);
		
	}
}

void BloodSplat(float fox, float foy, float fdx, float fdy)
{
	float fangle = atan2(fdy, fdx);
	for (int i = 0; i < rand()%20+100; i++)
	{
		float fpangle = (rand()%60) * fdegtorad + fangle;
		if (rand()%4 < 3)
		{
			float fspeed = (rand()%170)/10.0f + 5.0f;
			if (AddParticle(fox, foy, cos(fpangle) * fspeed, sin(fpangle) * fspeed, rand()%PARTLIFE+1, RED))
				break;
		}else
		{
			float fspeed = (rand()%170)/11.0f + 5.0f;
			if (AddParticle(fox, foy, cos(fpangle) * fspeed, sin(fpangle) * fspeed, rand()%PARTLIFE+1, TROLLGREEN))
				break;
		}
	}
}

int AddParticle(float fx, float fy, float fvx, float fvy, int ilife, int icolor)
{
	for (int i = 0; i < MAX_PARTICLE; i++)
	{
		if (!part[i]->balive)
		{
			part[i]->balive = true;
			part[i]->fx = fx;
			part[i]->fy = fy;
			part[i]->fvx = fvx;
			part[i]->fvy = fvy;
			part[i]->ilife = ilife;
			part[i]->icolor = icolor;
			break;
		}
	}
	if (i == MAX_PARTICLE)
		return 1;
	else
		return 0;
}

void SineWave_Logic()
{
	for (int i = 0; i < MAX_SINEWAVE; i++)
	{
		if (swave[i]->balive)
		{
			swave[i]->fx += swave[i]->fvx;
			swave[i]->fy += swave[i]->fvy;
			swave[i]->fstep += WAVESTEPINC;
			if ((swave[i]->fx < -WAVELENGTH) || (swave[i]->fx > SCREEN_W + WAVELENGTH) || (swave[i]->fy < -WAVELENGTH) || (swave[i]->fy > SCREEN_H + WAVELENGTH))
				swave[i]->balive = false;
			for (int x = 0; x < MAX_TROLL; x++)
			{
				if (troll[x]->balive)
				{
					if (sq(troll[x]->fx - swave[i]->fx) + sq(troll[x]->fy - swave[i]->fy) < sq(TROLL_SIZE) ||
						sq(troll[x]->fx - (swave[i]->fx + swave[i]->fcos*20)) + sq(troll[x]->fy - (swave[i]->fy + swave[i]->fsin*20)) < sq(TROLL_SIZE) ||
						sq(troll[x]->fx - (swave[i]->fx + swave[i]->fcos*40)) + sq(troll[x]->fy - (swave[i]->fy + swave[i]->fsin*40)) < sq(TROLL_SIZE) ||
						sq(troll[x]->fx - (swave[i]->fx + swave[i]->fcos*60)) + sq(troll[x]->fy - (swave[i]->fy + swave[i]->fsin*60)) < sq(TROLL_SIZE) ||
						sq(troll[x]->fx - (swave[i]->fx + swave[i]->fcos*80)) + sq(troll[x]->fy - (swave[i]->fy + swave[i]->fsin*80)) < sq(TROLL_SIZE))
					{
						if (troll[x]->ihp < 2)
						{
							troll[x]->balive = false;
							BloodSplat(troll[x]->fx, troll[x]->fy, swave[i]->fvx, swave[i]->fvy);
							iscore++;
						}else
							troll[x]->ihp--;
						swave[i]->balive = false;
					}
					

					
				}
			}
		}
	}
}

void Draw_SineWaves()
{
	float fcx1, fcy1, flx1, fly1, fcx2, fcy2, flx2, fly2;
	fcx1 = fcx2 = fcy1 = fcy2 = 0.0f;
	for (int i = 0; i < MAX_SINEWAVE; i++)
	{
		if (swave[i]->balive)
		{
			//float fcosp = cos(fangle+(PI*0.5f));
			//float fsinp = sin(fangle+(PI*0.5f));
			for (int x = 0; x < WAVELENGTH; x++)
			{			
				flx1 = fcx1;
				fly1 = fcy1;
				fcx1 = swave[i]->fx + (swave[i]->fcos*x) + ( swave[i]->fcosp * sin((x*6)*fdegtorad+swave[i]->fstep) * WAVEWIDTH );
				fcy1 = swave[i]->fy + (swave[i]->fsin*x) + ( swave[i]->fsinp * sin((x*6)*fdegtorad+swave[i]->fstep) * WAVEWIDTH );

				flx2 = fcx2;
				fly2 = fcy2;
				fcx2 = swave[i]->fx + (swave[i]->fcos*x) - ( swave[i]->fcosp * sin((x*6)*fdegtorad+swave[i]->fstep) * WAVEWIDTH );
				fcy2 = swave[i]->fy + (swave[i]->fsin*x) - ( swave[i]->fsinp * sin((x*6)*fdegtorad+swave[i]->fstep) * WAVEWIDTH );
				if (x) 
				{
					line(buffer, fcx1, fcy1, flx1, fly1, makecol32(96, 255, 0));
					line(buffer, fcx2, fcy2, flx2, fly2, makecol32(96, 255, 0));
				}

			}
		}
	}

}

int ShootSineWave(float fox, float foy, float fdx, float fdy)
{
	for (int i = 0; i < MAX_SINEWAVE; i++)
	{
		if (!swave[i]->balive)
		{
			swave[i]->fx = fox;
			swave[i]->fy = foy;
			float flen = sqrt(fdx*fdx + fdy*fdy);
			swave[i]->fvx = fdx/flen * WAVESPEED;
			swave[i]->fvy = fdy/flen * WAVESPEED;
			float fangle = atan2(fdy, fdx);
			swave[i]->fcos = cos(fangle);
			swave[i]->fsin = sin(fangle);
			swave[i]->fsinp = sin(fangle+(PI*0.5f));
			swave[i]->fcosp = cos(fangle+(PI*0.5f));
			swave[i]->balive = true;
			break;
		}
	}
	if (i == MAX_SINEWAVE)
		return 1;
	else
		return 0;
}